/*
 * Created on Oct 16, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package MVC;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.io.File;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;
import javax.swing.text.TabSet;
import javax.swing.text.TabStop;

import wikiviz.ArtifactList;

/**
 * author WikiViz
 * 
 * AppicationMainView is for the main application window. 
 * There is a controller that is associated with the window
 * that controls and handles the input events. There is also
 * a model associated with the window that represents the 
 * backend behind the GUI, that knows how to process the 
 * data input into the GUI.
 *  
 */

public class ApplicationMainView extends JApplet implements Observer {

	private Controller controller; // Handle input events
	private ArtifactList model; // Process input events

	private JButton bold; // Bold button
	private JButton italics; // Italics button
	private JButton underline; // Underline button
	private JButton hyperLink; // Hyperlink button
	private JButton save; // Save button
	private JButton load; //Load button
	private JButton bullets; // Bullet button
	private JButton header;
	private JButton cut;
	private JButton paste;
	private JButton undo;
	
	private boolean undoEnabled;
	public JTextPane textPane;// Text area into which input is typed
	public JScrollPane paneScrollPane;
	public StyledDocument doc;
	public CaretListenerLabel caretListenerLabel;
	/*
	 * Constructor for ApplicationMainView, which initializes
	 * the window and its components
	 */

	public ApplicationMainView() {
		super();

		// Initialize the buttons
		//undo = new JButton("Undo");
		//URL a = new URL("asdfasdfasdfasd");
		String fileString = new String("Images");
		fileString = fileString.concat(File.separator);
		bold = new JButton(new ImageIcon(fileString.concat("bold.jpg")));
		bold.setBackground(Color.gray);
		bold.setActionCommand("Bold");
		bold.setToolTipText("Bold");
		italics = new JButton(new ImageIcon(fileString.concat("italics.jpg")));
		italics.setBackground(Color.gray);
		italics.setActionCommand("Italics");
		italics.setToolTipText("Italics");
		underline = new JButton(new ImageIcon(fileString.concat("underline.jpg")));
		underline.setBackground(Color.gray);
		underline.setActionCommand("Underline");
		underline.setToolTipText("Underline");
		hyperLink = new JButton("HyperLink");
		hyperLink.setBackground(Color.gray);
		hyperLink.setToolTipText("Hyperlink");
		save = new JButton(new ImageIcon(fileString.concat("save.jpg")));
		save.setBackground(Color.gray);
		save.setActionCommand("Save");
		save.setToolTipText("Save As");
		bullets = new JButton(new ImageIcon(fileString.concat("bullets.jpg")));
		bullets.setBackground(Color.gray);
		bullets.setActionCommand("Bullets");
		bullets.setToolTipText("Bullets");
		cut = new JButton(new ImageIcon(fileString.concat("cut.jpg")));
		cut.setBackground(Color.gray);
		cut.setActionCommand("Cut");
		cut.setToolTipText("Cut");
		paste = new JButton(new ImageIcon(fileString.concat("paste.jpg")));
		paste.setBackground(Color.gray);
		paste.setActionCommand("Paste");
		paste.setToolTipText("Paste");
		load = new JButton(new ImageIcon(fileString.concat("load.jpg")));
		load.setBackground(Color.gray);
		load.setActionCommand("Load");
		load.setToolTipText("Load");
		header = new JButton("Header");
		header.setBackground(Color.gray);
		header.setToolTipText("Header");
		undo = new JButton(new ImageIcon(fileString.concat("undo.jpg")));
		undo.setActionCommand("Undo");
		undo.setToolTipText("Undo");
		undo.setBackground(Color.gray);
		undoEnabled = false;
		undo.setEnabled(undoEnabled);
		// Laying doen the components into the window
		getContentPane().setLayout(new FlowLayout());
		getContentPane().add(save);
		getContentPane().add(load);
		getContentPane().add(bold);
		getContentPane().add(italics);
		getContentPane().add(underline);
		getContentPane().add(cut);
		getContentPane().add(paste);
		getContentPane().add(bullets);
		getContentPane().add(undo);
		getContentPane().add(hyperLink);
		
		getContentPane().add(header);
		
		// Instantiate a new TextArea
		// 40 lines and 90 character columns
		textPane = new JTextPane();
		textPane.setRequestFocusEnabled(true);
				
		paneScrollPane = new JScrollPane(textPane);
		paneScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		textPane.setPreferredSize(new Dimension(800, 800));
		textPane.setMinimumSize(new Dimension(800, 800));
		
		java.util.List list = new ArrayList();
		TabStop tstop;
		int align,leader;
		
		for (int i =30; i <=300; i+=30) {
			align = TabStop.ALIGN_LEFT;
			leader = TabStop.LEAD_DOTS;
			tstop = new TabStop(i,align,leader);
			list.add(tstop);
		}
		TabStop[] tstops = (TabStop[])list.toArray(new TabStop[0]);
		TabSet tabs = new TabSet(tstops);
		Style style = textPane.getLogicalStyle();
		StyleConstants.setTabSet(style, tabs);
		textPane.setLogicalStyle(style);

		
		paneScrollPane.setPreferredSize(new Dimension(800, 700));
		paneScrollPane.setMinimumSize(new Dimension(800, 700));
		

		caretListenerLabel = new CaretListenerLabel("Caret Status");

		doc = textPane.getStyledDocument();
		addStylesToDocument(doc);
		getContentPane().add(paneScrollPane, BorderLayout.SOUTH);
	}

	/*
	 * Sets up the handlers that handle different buttons
	 */
	public void insert(String s) {
		textPane.setText(s);
	}
	
	public boolean isUndoEnabled() {
		return undoEnabled;
	}
	public void enableUndo() {
		undoEnabled = true;
		undo.setEnabled(undoEnabled);
		
	}
	
	public void disableUndo() {
		undoEnabled = false;
		undo.setEnabled(undoEnabled);
		
	}
	public void removeAndReplace(String remText) {
			try {
				getStyledoc().remove(getStyledoc().getLength()-remText.length(),
							remText.length());
				getStyledoc().insertString(textPane.getCaretPosition(),remText,getStyledoc().getStyle("URL"));
			} catch (BadLocationException e) {
				
				e.printStackTrace();
			}
		
		}
	private void setUpButtonHandler() {
		textPane.addCaretListener(caretListenerLabel);
		bold.addActionListener(controller);
		italics.addActionListener(controller);
		underline.addActionListener(controller);
		hyperLink.addActionListener(controller);
		save.addActionListener(controller);
		bullets.addActionListener(controller);
		textPane.addKeyListener(controller);
		textPane.addMouseListener(controller);
		load.addActionListener(controller);
		cut.addActionListener(controller);
		paste.addActionListener(controller);
		header.addActionListener(controller);
		undo.addActionListener(controller);
	}

	public StyledDocument getStyledoc() {
		return doc;
	}

	protected void addStylesToDocument(StyledDocument doc) {
		//Initialize some styles.
		Style def =
			StyleContext.getDefaultStyleContext().getStyle(
				StyleContext.DEFAULT_STYLE);

		Style regular = doc.addStyle("regular", def);
		StyleConstants.setFontFamily(def, "SansSerif");

		Style s = doc.addStyle("italic", regular);
		StyleConstants.setItalic(s, true);
		
		s = doc.addStyle("underline", regular);
		StyleConstants.setUnderline(s, true);

		s = doc.addStyle("bold", regular);
		StyleConstants.setBold(s, true);

		s = doc.addStyle("bolditalic", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setItalic(s, true);

		s = doc.addStyle("bolditalicunderline", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setItalic(s, true);
		StyleConstants.setUnderline(s, true);

		s = doc.addStyle("boldunderline", regular);
		StyleConstants.setBold(s, true);
		StyleConstants.setUnderline(s, true);

		s = doc.addStyle("italicunderline", regular);
		StyleConstants.setItalic(s, true);
		StyleConstants.setUnderline(s, true);
		
		s = doc.addStyle("h1", regular);
		StyleConstants.setFontSize(s, 24);

		s = doc.addStyle("h2", regular);
		StyleConstants.setFontSize(s, 20);
		
		s = doc.addStyle("h3", regular);
		StyleConstants.setFontSize(s, 16);

		s = doc.addStyle("h4", regular);
		StyleConstants.setFontSize(s, 14);
				
		s = doc.addStyle("h5", regular);
		StyleConstants.setFontSize(s, 12);

		s = doc.addStyle("h6", regular);
		StyleConstants.setFontSize(s, 10);
		
		s = doc.addStyle("URL", regular);
		StyleConstants.setUnderline(s,true);
		StyleConstants.setForeground(s,Color.BLUE);
		
		s = doc.addStyle("icon", regular);
		StyleConstants.setAlignment(s, StyleConstants.ALIGN_CENTER);
	}

	/* 
	 * To implement the observer. Added by Danny Dig, not really
	 * needed till now. This method needs to be defined to 
	 * implement Observer.
	 */
	public void update() {
		textPane.requestFocus();	
	}

	/*
	 * return Controller object
	 */
	public Controller getController() {
		return controller;
	}

	/**
	 * return Model object
	 */
	public ArtifactList getModel() {
		return model;
	}

	/**
	 * @param controller object (set controller)
	 */
	public void setController(Controller controller) {
		this.controller = controller;
		setUpButtonHandler();
	}

	/**
	 * @param list object (set model)
	 */
	public void setModel(ArtifactList list) {
		model = list;
	}


	public class CaretListenerLabel extends JLabel  implements CaretListener {
			public CaretListenerLabel (String label) {
				super(label);
			}
			String newline = "\n";
			public void caretUpdate(CaretEvent e) {
				//Get the location in the text.
				int dot = e.getDot();
				int mark = e.getMark();
				if (dot == mark) {  // no selection 
					try {
						Rectangle caretCoords = textPane.modelToView(dot);
						controller.selectEnd = 0;
						controller.selectStart = 0;
						//Convert it to view coordinates.
					} catch (BadLocationException ble) {
						setText("caret: text position: " + dot + newline);
					}
				} else if (dot < mark) {
					controller.selectEnd = mark;
					controller.selectStart = dot;
					System.out.println("selection from: " + dot	+ " to " + mark + newline);
				} else {
					controller.selectEnd = mark;
					controller.selectStart = dot;
					System.out.println("selection from: " + dot + " to " + mark + newline);
				}
			}
		}
	
}
