/*
 * Created on Oct 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test;

import MVC.ApplicationMainView;
import MVC.Controller;
import junit.framework.TestCase;
import wikiviz.ArtifactList;
import wikiviz.BoldArtifact;

/**
 * @author Larry Benchimol
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ArtifactListTest extends TestCase {

	/**
	 * Constructor for ArtifactListTest.
	 * @param arg0
	 */
	public ArtifactListTest(String arg0) {
		super(arg0);
	}

	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/*
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testToWiki() {
		boolean [] stylebits = new boolean[4];
		
		stylebits[0]= false;
		stylebits[1]= true;
		stylebits[2]= false;
		stylebits[3]= false;

        BoldArtifact b1 = new BoldArtifact(stylebits);
        b1.subArt.subArt.setText("BOLD-ITALICS");
		assertEquals("<b><i>BOLD-ITALICS</i></b>", b1.toWiki());
	}
	
	public void testHandleBackspace() {
	
		ArtifactList testArtifactList = new ArtifactList();
		testArtifactList.addObserver(new ApplicationMainView());
		testArtifactList.addObserver(new Controller());
		String temp1 = "bold";
		String temp2 = "pl";

		testArtifactList.appendChar('a');
		testArtifactList.appendChar('b');
		testArtifactList.appendChar('c');
		testArtifactList.appendChar('d');
		testArtifactList.appendChar('e');
		testArtifactList.appendChar('f');
		assertEquals("abcdef", testArtifactList.toWiki());
		
		testArtifactList.handleBold();
		appendHelper(testArtifactList, temp1);
		testArtifactList.handleBold();
		appendHelper(testArtifactList, temp2);
		
		//simulate pressing backspace 3 times
		testArtifactList.handleBackspace();
		testArtifactList.handleBackspace();
		testArtifactList.handleBackspace();
		
		//now it should be "abc"
		assertEquals("abcdef<b>bol</b>", testArtifactList.toWiki());
		
		testArtifactList.appendChar('d');
		
		assertEquals("abcdef<b>bold</b>", testArtifactList.toWiki());
	}
	

    private void appendHelper(ArtifactList al, String s) {
    	int i = 0;
    	while (i < s.length())
    		al.appendChar(s.charAt(i++));	
    }
    
	public void testBullets() {
		//Initialize some strings which we can insert later
		
		//this is the desired output string
		String desiredOutput = new String("this is fun\n*this is level 1\n**this is level 2\n*this is again a level 1 bullet\nthis is not a bullet");
		String temp1 = new String("this is fun\n");
		String temp2 = new String("this is level 1\n");
		String temp3 = new String("this is level 2\n");
		String temp5 = new String("this is again a level 1 bullet\n");
		String temp4 = new String("this is not a bullet");
		
		ArtifactList al = new ArtifactList();
		al.addObserver(new ApplicationMainView());
		al.addObserver(new Controller());
		appendHelper(al, temp1);//append "this is fun as normal text"
		al.handleBullet();//simulate the starting of a bullet
		appendHelper(al, temp2); //append "this is level 1" as a level 1 bullet
		al.handleBullet(); //simulate the starting of another bullet level
		appendHelper(al, temp3);//append "this is level 2" as a level 2 bullet
		al.handleEndBullet(); //simulate the ending of a bullet
		appendHelper(al, temp5);//append "this is again a level 1 bullet" as back to level 1
								//  since we ended a bullet
		al.handleEndBullet(); //simulate the ending of a bullet
		appendHelper(al, temp4); //append "this is not a bullet" as normal text after ending all bullets

		assertEquals(desiredOutput, al.toWiki()); //check to see if it works
	}
	
	public void testHandleBold(){
		ArtifactList testArtifactList = new ArtifactList();
		testArtifactList.addObserver(new ApplicationMainView());
		testArtifactList.addObserver(new Controller());
		
		String temp1 = new String("this is plain ");
		String temp2 = new String("this is bold ");
		String temp3 = new String("this is bold-italic ");
	
		appendHelper(testArtifactList, temp1); //append "this is plain"
		assertEquals(temp1, testArtifactList.toWiki());

		//start bold tag
		testArtifactList.handleBold();
		appendHelper(testArtifactList, temp2); //append "this is bold" 
		
		//should be within the bold tags
		assertEquals("this is plain <b>this is bold </b>", testArtifactList.toWiki());
		
		//start italics tag
		testArtifactList.handleItalic();
		appendHelper(testArtifactList, temp3); //print this within the italics tag
		testArtifactList.handleItalic(); //end your italics tag
		testArtifactList.handleBold(); //end your bold tag
		
		assertEquals("this is plain <b>this is bold </b><b><i>this is bold-italic </i></b>", testArtifactList.toWiki());	
	}
}