/*
 * Created on Mar 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test;

import MVC.ApplicationMainView;
import MVC.Controller;
import junit.framework.TestCase;
import wikiviz.ArtifactList;
import wikiviz.TextArtifact;

/**
 * @author WikiViz
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SystemTest extends TestCase {

	/**
	 * Constructor for SystemTest.
	 * @param arg0
	 */
	public SystemTest(String arg0) {
		super(arg0);
	}
	
	public static void appendHelper(ArtifactList al, String s) {
		int i = 0;
		while (i < s.length())
			al.appendChar(s.charAt(i++));	
	}
	
	public void testWholeSystem() {
		TextArtifact testArtifact = new TextArtifact();
		
		ArtifactList testArtifactList = new ArtifactList();
		testArtifactList.addObserver(new ApplicationMainView());
		testArtifactList.addObserver(new Controller());
		
		ArtifactList testArtifactList2 = new ArtifactList();
		testArtifactList2.addObserver(new ApplicationMainView());
		testArtifactList2.addObserver(new Controller());
		
		String temp1 = new String("this is plainer");
		String temp2 = new String("this is bold");
		String temp3 = new String("this is bold-italic");
		String temp4 = new String("bold ");
		String temp5 = new String("plain ");
		
		appendHelper(testArtifactList, temp1);
		assertEquals(temp1, testArtifactList.toWiki());
		
		testArtifactList.handleBackspace();
		testArtifactList.handleBackspace();
		
		//check to see if the backspace worked and removed "er"
		assertEquals("this is plain", testArtifactList.toWiki());
		
		//put a space for separation
		testArtifactList.appendChar(' ');
		
		//start bold tag
		testArtifactList.handleBold();
		
		//add the text "this is bold"
		appendHelper(testArtifactList, temp2);
		
		//end the bold tag
		testArtifactList.handleBold();
		
		assertEquals("this is plain <b>this is bold</b>", testArtifactList.toWiki());
		
		testArtifactList.appendChar(' '); //add space for separation
		testArtifactList.handleBold(); //start bold tag
		testArtifactList.handleItalic(); //start italic tag
		appendHelper(testArtifactList, temp3); //type "this is bold-italic"
		testArtifactList.handleItalic(); //end the italic tag
		testArtifactList.handleBold(); //end the bold tag
		
		//check to see if it matches with what it should be
		assertEquals("this is plain <b>this is bold</b> <b><i>this is bold-italic</i></b>", testArtifactList.toWiki());
		
		temp1 = "this is ";
		temp2 = "bold ";
		temp3 = "bold-italic ";
		
		appendHelper(testArtifactList2, temp1);  //type "this is"
		testArtifactList2.handleBold();  //start the bold tag
		appendHelper(testArtifactList2, temp2); //type "bold"
		testArtifactList2.handleItalic(); //start the italic tag (the way the implemetation works...
										  //  is that it ends the old bold tag, and then starts a new
										  //  bold and italic tag.
		appendHelper(testArtifactList2, temp3);//type "bold-italic "
		testArtifactList2.handleItalic();//end the italic tag (this ends the italic and bold and
										 //  starts bold
		appendHelper(testArtifactList2, temp4);//type "bold"
		testArtifactList2.handleBold(); //end the bold tag
		appendHelper(testArtifactList2, temp5); //just type "plain"
		
		assertEquals("this is <b>bold </b><b><i>bold-italic </i></b><b>bold </b>plain ", testArtifactList2.toWiki());
	}
	
	public void testLoad() {
		
		//beginning part is the same as the test above
		ArtifactList testArtifactList = new ArtifactList();
		testArtifactList.addObserver(new ApplicationMainView());
		testArtifactList.addObserver(new Controller());

		String temp1 = new String("this is plainer");
		String temp2 = new String("this is bold");
		String temp3 = new String("this is bold-italic");
		String temp4 = new String("bold ");
		String temp5 = new String("plain ");

		appendHelper(testArtifactList, temp1);
		assertEquals(temp1, testArtifactList.toWiki());
		
		
		testArtifactList.handleBackspace();
		testArtifactList.handleBackspace();
		
		assertEquals("this is plain", testArtifactList.toWiki());
		
		testArtifactList.appendChar(' ');
		
		testArtifactList.handleBold();
		
		appendHelper(testArtifactList, temp2);
		
		testArtifactList.handleBold();
		
		assertEquals("this is plain <b>this is bold</b>", testArtifactList.toWiki());
		
		testArtifactList.appendChar(' ');
		testArtifactList.handleBold();
		testArtifactList.handleItalic();
		appendHelper(testArtifactList, temp3);
		testArtifactList.handleItalic();
		testArtifactList.handleBold();
		
		assertEquals("this is plain <b>this is bold</b> <b><i>this is bold-italic</i></b>", testArtifactList.toWiki());
		
		//Now lets try to save this file so we can load and check to see if works
		try {
			testArtifactList.outputWikiDoc("c:\\systemTest.wiki"); //save to the file C:\systemTest.wiki
		} catch (Exception e) {
			
			e.printStackTrace();
		}		
		
		ArtifactList model = new ArtifactList();
		model.addObserver(new ApplicationMainView());
		model.addObserver(new Controller());
		
		try {
			model.loadFile("c:\\systemTest.wiki"); //load the file you just saved
		} catch (Exception e) {
			
			e.printStackTrace();
		}
		//see if what you loaded contains what it is supposed to
		//	essentially validating whether load worked or not
		assertEquals(
			"this is plain <b>this is bold</b> <b><i>this is bold-italic</i></b>", model.toWiki());
	}
}