/*
 * Created on May 3, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test;

import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

import MVC.ApplicationMainView;
import MVC.Controller;
import wikiviz.ArtifactList;
import junit.framework.TestCase;

/**
 * @author WikiViz
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestCutAndPaste extends TestCase {

	/**
	 * Constructor for CutTest.
	 * @param arg0
	 */
	public TestCutAndPaste(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
	}
	
	public static void appendHelper(ArtifactList al, String s) {
		int i = 0;
		while (i < s.length())
			al.appendChar(s.charAt(i++));	
	}

	public void testCutAndPaste() {
		ArtifactList testArtifactList = new ArtifactList();
		testArtifactList.addObserver(new ApplicationMainView());
		testArtifactList.addObserver(new Controller());
		
		String clip = new String();
		String temp1 = new String("this is plain");
		String temp2 = new String("this is bold");
		String temp3 = new String("this is bold-italic");
		String temp4 = new String("bold ");
		String temp5 = new String("plain ");

		appendHelper(testArtifactList, temp1);
		testArtifactList.appendChar(' ');
		
		testArtifactList.handleBold();
		appendHelper(testArtifactList, temp2);
		testArtifactList.handleBold();

		assertEquals("this is plain <b>this is bold</b>", testArtifactList.toWiki());

		testArtifactList.appendChar(' ');
		testArtifactList.handleBold();
		testArtifactList.handleItalic();
		appendHelper(testArtifactList, temp3);
		testArtifactList.handleItalic();
		testArtifactList.handleBold();

		//Set the selection to highlight the string "plain"
		testArtifactList.getController().selectStart = 8;
		testArtifactList.getController().selectEnd = 13;
		
		//CUT the string "plain"
		String cutText = testArtifactList.cutSelection();
		StringSelection s = new StringSelection(cutText);
		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(s,s);
		
		assertEquals("this is  <b>this is bold</b> <b><i>this is bold-italic</i></b>", testArtifactList.toWiki());
		
		try {
			clip = (String)(Toolkit.getDefaultToolkit().getSystemClipboard().getContents(new Object()).getTransferData(DataFlavor.stringFlavor));
			assertEquals("plain", clip);
		} catch (HeadlessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedFlavorException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//First update the position to before the letter 'b'
		testArtifactList.updatePosition(17);
		
		//Paste the string at the current position
		for (int i = 0; i < clip.length(); i++) {
			testArtifactList.appendChar(clip.charAt(i));
		}
		assertEquals("this is  <b>this is plainbold</b> <b><i>this is bold-italic</i></b>", testArtifactList.toWiki());
	}
}
