/*
 * Created on Oct 16, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package wikiviz;
//import java.lang.*;

/**
 * @author wikiwiz
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Artifact{

	// As user enters text in the text area in GUI that
	// text is saved in String "text"
	// whereInText keeps track of the position in the text string
	public Artifact subArt;
	protected String styleString = "";
	protected String startTag;
	protected String endTag;
	private boolean[] styleBits;

	public Artifact() {
		startTag = new String("");
		endTag = new String("");
		//subArt = new TextArtifact();
		styleBits = new boolean[4];
		for(int i = 0; i < 4; i++) {
			styleBits[i] = false;
		}
	}

	public Artifact(String setText) {
		subArt = new TextArtifact();
		subArt.setText(setText);	
		startTag = new String("");
		endTag = new String("");
	}
	
	public Artifact(boolean[] styleBits) {
		boolean [] styleCopy = CopyStyle(styleBits);
		startTag = new String("");
		endTag = new String("");
		this.styleBits = CopyStyle(styleBits);
		int i = 0; 
		while ((i<4) && !styleCopy[i])
			i++;
		if (i < 4)
			styleCopy[i] = false;
		switch(i) {
			case 0:
				subArt = new BoldArtifact(styleCopy);
				break;
			case 1:
				subArt = new ItalicArtifact(styleCopy);
				break;
			case 2:
				subArt = new UnderlineArtifact(styleCopy);
				break;
			case 3:
				subArt = new URLArtifact(styleCopy);
				break;
			case 4:
				subArt = new TextArtifact(1);
				break;
		}
	}

	public boolean[] CopyStyle(boolean[] styleBits) {
		boolean[] styleCopy = new boolean[4];
		for (int i = 0; i < 4; i++)
			styleCopy[i] = styleBits[i];
		
		return styleCopy;
	}

	public String deleteChar(){
		return subArt.deleteChar();	
	}

	//sets the text of the artifact
	public void setText(String textArtifact) {
		//text = textArtifact;
		//whereInText = text.length()-1;
		subArt.setText(textArtifact);
	}
		
	public boolean[] getStyleBits() {
		return CopyStyle(styleBits);
	}
	
	public String getStyleString(){
		return styleString.concat(subArt.getStyleString());
	}
	
	//returns the string stored in the artifact
	public String getText() {
		return subArt.getText();
	}
	
	// we can set the position in the text
	public void setWhereInText(int i) {
		subArt.setWhereInText(i);
	}
	
	// Retrive whereInText
	public int getWhereInText () {
		return subArt.getWhereInText();
	}
	
	//set the position to the end of the text
	public void setWhereInTextToEnd() {
		//whereInText = text.length();
		subArt.setWhereInTextToEnd();
	}
	
	//true if at the end of the text
	public boolean isAtEndOfArtifact() {
		return subArt.isAtEndOfArtifact();
	}
	
	public boolean isAtStart() {
		return subArt.isAtStart();
	}
	
	//adds the newChar to the appropriate position in the text
	public void append(char newChar) {
		subArt.append(newChar);
	}
	
	//removes numChars characters from the current position in the text
	public String removeChars(int numChars) {
		return subArt.removeChars(numChars);
	}
	
	//This function returns the lentgh the input string that user
	//typed in text area in GUI
	public int numOutputChars() {
		return subArt.numOutputChars();
	}
	
	//This function returns the string that was typed
	public String toWiki() {
		
		if(subArt.getText().equals(""))
			return "";
			
		String returnString = startTag;
		String subText = subArt.toWiki();
		returnString = (returnString.concat(subText)).concat(endTag);
		
		return returnString;
	}
	
	public int getBulletNum() {
		return 0;
	}
	
}

