/*
 * Created on Oct 19, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package wikiviz;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import javax.swing.text.BadLocationException;

import MVC.ApplicationMainView;
import MVC.Controller;
import MVC.Observer;

/**
 * @author wikiwiz
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ArtifactList {

	private List observers = new ArrayList();
	private Vector artifacts;
	private int artIndex;
	private int numArtifacts;
	private int indentLevel;
	private char[] last7Chars;
	private boolean[] styleBits;
	private File undoDir;
	private int undoSuffix;
	private String currentUndoFilename;
	//The constructor creates the artifact Vector and initializes the indentation level, the artifact index, and the number of artifacts
	//The vector starts with one artifact already in it.
	public ArtifactList() {
		styleBits = new boolean[4];
		for (int i = 0; i < 4; i++) {
			styleBits[i] = false;
		}
		artifacts = new Vector(10);
		artifacts.add(new Artifact(styleBits));
		artIndex = 0;
		numArtifacts = 1;
		indentLevel = 0;
		last7Chars = new char[7];
		for (int i = 0; i < 7; i++)
			last7Chars[i] = 'a';
		undoDir = new File("C:\\WikiVizTemp");
		undoDir.deleteOnExit();
		undoDir.mkdirs();

		undoSuffix = 0;
	}

	public void loadFile(String filename) throws IOException {
		FileInputStream fin = new FileInputStream(filename);
		String retString = new String("");
		while (fin.available() > 0)
			retString = retString.concat(String.valueOf((char) fin.read()));
		loadFromString(retString);
		fin.close();
	}

	public void loadFromString(String wikiCode) {
		for (int i = 0; i < 4; i++) {
			styleBits[i] = false;
		}
		artifacts = new Vector(10);
		artifacts.add(new Artifact(styleBits));
		artIndex = 0;
		numArtifacts = 1;
		indentLevel = 0;
		char c;

		String showInGUI = new String("");
		String bulletString = new String("");
		int countBangs = 0;
		int i = 0;
		while (i < wikiCode.length()) {

			c = (char) wikiCode.charAt(i);
			i++;
			countBangs = 0;
			while (c == '!') {
				countBangs++;
				c = (char) wikiCode.charAt(i);
				i++;
			}
			if (countBangs != 0) {
				handleHeader(countBangs);
			}

			if (c == '<') {
				c = (char) wikiCode.charAt(i);
				i++;
				if (c == '/') {
					c = (char) wikiCode.charAt(i);
					i++;
				}
				if (c == 'b') {
					handleBold();
				} else if (c == 'i') {
					handleItalic();
				} else if (c == 'u') {
					handleUnderline();
				}
				i++;
			} else if (c == '*') {
				handleBullet();
			} else if (c == '\n') {
				indentLevel = 0;
				addArtifact(new Artifact(styleBits));
				appendChar(c);
			} else if (c == '[') {

				String urlString = new String("");
				c = (char) wikiCode.charAt(i);
				i++;
				while (c != ']') {
					urlString = urlString.concat(String.valueOf(c));
					c = (char) wikiCode.charAt(i);
					i++;
				}
				addArtifact(new Artifact(getURLStyle()));
				getCurrentArtifact().setText(urlString);
				//NEED TO DO THIS
			} else {
				appendChar(c);
			}

		}
		try {
			getView().getStyledoc().remove(
				0,
				getView().getStyledoc().getLength());
		} catch (BadLocationException e1) {

			e1.printStackTrace();
		}
		for (i = 0; i < artifacts.size(); i++) {
			showInGUI = ((Artifact) (artifacts.get(i))).getText();
			bulletString = "";

			try {
				if (((Artifact) (artifacts.get(i))).getBulletNum() > 0) {
					for (int j = 1;
						j < ((Artifact) (artifacts.get(i))).getBulletNum();
						j++) {
						bulletString = bulletString.concat("\t");
					}
					bulletString =
						bulletString.concat(String.valueOf(((char) 164)));
					bulletString = bulletString.concat(" ");
					((ApplicationMainView) (observers.get(0)))
						.getStyledoc()
						.insertString(
						((ApplicationMainView) (observers.get(0)))
							.getStyledoc()
							.getLength(),
						bulletString,
						((ApplicationMainView) (observers.get(0)))
							.getStyledoc()
							.getStyle(
							((Artifact) (artifacts.get(i))).getStyleString()));
				}
				getView().getStyledoc().insertString(
					getView().getStyledoc().getLength(),
					showInGUI,
					getView().getStyledoc().getStyle(
						((Artifact) (artifacts.get(i))).getStyleString()));
			} catch (Exception e) {

				e.printStackTrace();
			}
		}

	}

	private ApplicationMainView getView() {
		return ((ApplicationMainView) (observers.get(0)));
	}
	public Controller getController() {
		return ((Controller) (observers.get(1)));
	}
	public void handleBold() {
		if (getController().selectEnd == getController().selectStart) {
			styleBits[0] = !(styleBits[0]);
			addArtifact(new Artifact(styleBits));
		} else {
			reformatSelection(0);
		}
	}

	private void reformatSelection(int bitNum) {
		int selStart = getController().selectStart,
			selEnd = getController().selectEnd;
		int firstArt, lastArt;
		boolean[] sb = new boolean[4];
		if (selStart > selEnd) {
			selStart = getController().selectEnd;
			selEnd = getController().selectStart;
		}
		getController().selectEnd = 0;
		getController().selectStart = 0;
		updatePosition(selStart);
		firstArt = artIndex;
		if (getCurrentArtifact().getWhereInText() > 0
			&& getCurrentArtifact().getWhereInText()
				< getCurrentArtifact().getText().length()) {
			splitArtifact();
			firstArt = artIndex;
		}
		updatePosition(selEnd);
		lastArt = artIndex;
		if (getCurrentArtifact().getWhereInText() > 0
			&& getCurrentArtifact().getWhereInText()
				< getCurrentArtifact().getText().length()) {
			splitArtifact();
			lastArt = artIndex - 1;
		}
		while (firstArt <= lastArt) {
			sb = getArtifact(firstArt).getStyleBits();
			sb[bitNum] = !sb[bitNum];
			Artifact temp = new Artifact(sb);
			temp.setText(getArtifact(firstArt).getText());
			artifacts.remove(firstArt);
			artifacts.add(firstArt, temp);
			firstArt++;
		}
		/*outputWikiDoc("C:\\thisiscraziness.wiki");
		try {
			loadFile("C:\\thisiscraziness.wiki");
		} catch (IOException e) {

			e.printStackTrace();
		}*/
		loadFromString(toWiki());
		updatePosition(selEnd);
		getView().textPane.setCaretPosition(selEnd);

	}

	public void handleHeader(int depth) {
		addArtifact(new HeaderArtifact(styleBits, depth));
	}

	public void handleItalic() {
		if (getController().selectEnd == getController().selectStart) {
			styleBits[1] = !(styleBits[1]);
			addArtifact(new Artifact(styleBits));
		} else {
			reformatSelection(1);
		}
	}

	public void handleUnderline() {
		if (getController().selectEnd == getController().selectStart) {
			styleBits[2] = !(styleBits[2]);
			addArtifact(new Artifact(styleBits));
		} else {
			reformatSelection(2);
		}
	}

	public void handleURL() {
		//styleBits[3] = !(styleBits[3]);

		addArtifact(new Artifact(getURLStyle()));
	}

	public void undo() {
		//String undoFileName = new String ("C:\\WikiVizTemp\\");
		//undoFileName = (undoFileName.concat(String.valueOf(undoSuffix)));

		undoSuffix--;

		try {
			loadFile(currentUndoFilename);
			int numDigits =
				((int) (Math.log(undoSuffix + 1) / Math.log(10))) + 1;
			int pos = currentUndoFilename.lastIndexOf('\\') + 1;
			int tempNum =
				Integer.parseInt(
					currentUndoFilename.substring(
						pos + 2 + numDigits,
						currentUndoFilename.length() - 5))
					- 1;
			currentUndoFilename =
				currentUndoFilename.substring(0, pos)
					+ "00"
					+ undoSuffix
					+ String.valueOf(tempNum)
					+ ".wiki";
			//System.out.println("undo: numdigits: "+String.valueOf(numDigits)+"     filename:  "+currentUndoFilename);
		} catch (IOException e) {

			e.printStackTrace();
		}
		if (undoSuffix <= 0)
			getView().disableUndo();
	}

	public void updateUndoFile() {
		undoSuffix++;
		File undoFile;
		try {
			undoFile =
				File.createTempFile("00" + String.valueOf(undoSuffix), ".wiki");
			currentUndoFilename = undoFile.getAbsolutePath();
		} catch (IOException e) {

			e.printStackTrace();
		}
		//System.out.println(currentUndoFilename);
		//String undoFileName = new String ("C:\\WikiVizTemp\\");
		//undoFileName = (undoFileName.concat(String.valueOf(undoSuffix)));

		outputWikiDoc(currentUndoFilename);
		getView().enableUndo();
	}

	public boolean isBullet() {
		//if (indentLevel == 0)
		//if(getCurrentArtifact().)
		//return false;
		//else
		//	return true;
		return (getCurrentArtifact().getBulletNum() != 0);
	}

	//This handles the bullet event
	//This creates a new bullet artifact
	//If this occurs when already in a bullet artifact, we want that to further indent the bullet, otherwise not
	public String handleBullet() {

		if ((getCurrentArtifact() instanceof BulletArtifact)
			&& (getCurrentArtifact().getText() == "")) {

			artifacts.setElementAt(
				new BulletArtifact(styleBits, ++indentLevel),
				artIndex);
		} else {
			addArtifact(new BulletArtifact(styleBits, ++indentLevel));
		}
		String bulletString = new String("");
		for (int j = 1; j < indentLevel; j++) {
			bulletString = bulletString.concat("\t");
		}
		bulletString = bulletString.concat(String.valueOf(((char) 164)));
		//bulletString = bulletString.concat(" ");
		return bulletString;

	}

	//This handles the end bullet event
	//This decrements the indentation level if the bullet is higher than level 1, otherwise it stops bulleting the text.

	public String handleEndBullet() {
		if (((artifacts.elementAt(artIndex)) instanceof BulletArtifact)) {
			indentLevel--;

			if (indentLevel < 1) {
				indentLevel = 0;
				if (getCurrentArtifact().getText() == "") {

					artifacts.setElementAt(new Artifact(styleBits), artIndex);
				} else {
					addArtifact(new Artifact(styleBits));
				}

			} else {
				indentLevel--;
				handleBullet();
			}
		}
		String bulletString = new String("");
		for (int j = 1; j < indentLevel; j++) {
			bulletString = bulletString.concat("\t");
		}
		if (indentLevel != 0) {
			bulletString = bulletString.concat(String.valueOf(((char) 164)));
			//bulletString = bulletString.concat(" ");
		}
		return bulletString;
	}

	private boolean[] getURLStyle() {
		boolean[] justURL = new boolean[4];
		for (int i = 0; i < 2; i++) {
			justURL[i] = false;
		}
		justURL[3] = true;

		return justURL;
	}

	//This functions handles the Enter key being pressed
	//A special function was required because of the unique behavior that we expect
	//when Enter is pressed inside a bulleted list.  We would like another bullet to begin on the next line.

	public String handleEnter() {
		String temp = new String("\n");
		if (getCurrentArtifact() instanceof HeaderArtifact
			|| getCurrentArtifact().subArt instanceof URLArtifact) {
			addArtifact(new Artifact(styleBits));
		}
		if (indentLevel == 0) {
			appendChar('\n');
			return "";
		} else {
			indentLevel--;
			appendChar('\n');
			return temp.concat(handleBullet());
		}
	}

	public void handleSpace() {
		if (getCurrentArtifact().subArt instanceof URLArtifact)
			addArtifact(new Artifact(styleBits));
		appendChar(' ');
	}

	public void handleBackspace() {

		if (getCurrentArtifact().getWhereInText() <= 0
			|| getCurrentArtifact().getText().equals("")) {
			if (artIndex != 0) {
				if (getCurrentArtifact().getText().equals("")) {
					if (isBullet()) {
						for (int i = 1;
							i < getCurrentArtifact().getBulletNum();
							i++)
							(
								(Artifact) artifacts.elementAt(
									artIndex - 1)).append(
								'\t');
						((Artifact) artifacts.elementAt(artIndex - 1)).append(
							'z');
					}
					artifacts.remove(artIndex);
					artIndex--;
					numArtifacts--;
					getCurrentArtifact().setWhereInTextToEnd();
				}
			} else
				return;
		}
		String a = getCurrentArtifact().deleteChar();
		//		System.out.println(a);
		while (a.equals("")
			&& artIndex > 0
			&& getCurrentArtifact().getText().equals("")) {
			if (isBullet()) {
				for (int i = 1; i < getCurrentArtifact().getBulletNum(); i++)
					((Artifact) artifacts.elementAt(artIndex - 1)).append('\t');
				((Artifact) artifacts.elementAt(artIndex - 1)).append('z');
			}
			artifacts.remove(artIndex);
			artIndex--;
			numArtifacts--;
			getCurrentArtifact().setWhereInTextToEnd();

		}

	}
	public boolean isCurrentArtifactEmpty() {
		return getCurrentArtifact().getText().equals("");
	}

	public char getCurrentChar() {
		return getCurrentArtifact().getText().charAt(
			getCurrentArtifact().getWhereInText() - 1);
	}

	//When a regular character is entered, the ArtifactList passes it on to the current Artifact's append function
	public void appendChar(char appendChar) {
		getCurrentArtifact().append(appendChar);

		if (getCurrentArtifact().getText().endsWith("http://")) {
			//System.out.println("here");
			if (!getCurrentArtifact().removeChars(7).equals("http://")) {
				System.out.println("VERY BAD");
				//throw(new Exception());
			}

			Artifact a = new Artifact(getURLStyle());
			a.setText("http://");
			addArtifact(a);
			getView().removeAndReplace("http:/");
		} else if (
			getCurrentArtifact().getText().endsWith("www.")
				&& !getCurrentArtifact().getText().endsWith("http://www.")) {

			if (!getCurrentArtifact().removeChars(4).equals("www.")) {
				System.out.println("VERY BAD");
				//throw(new Exception());
			}

			Artifact a = new Artifact(getURLStyle());
			a.setText("www.");
			addArtifact(a);
			getView().removeAndReplace("www");
		}
	}

	public int getNumCurrentBulletChars() {
		if (indentLevel == 0)
			return 0;
		return getCurrentArtifact().getBulletNum() + 1;
	}
	//Returns the index of the current Artifact we are at
	public int getIndex() {
		return artIndex;
	}

	//Creates a new basic Artifact, adds it to the end of the list and updates artIndex and numArtifacts
	public void addArtifact(Artifact newArt) {
		if ((!getCurrentArtifact().isAtEndOfArtifact())) {
			splitArtifact();
		} else if ((getCurrentArtifact().isAtEndOfArtifact())) {
			artIndex++;
		}
		artifacts.add(artIndex, newArt);
		numArtifacts++;
	}

	//This iterates across all of the Artifacts in the ArtifactList, calls toWiki on each Artifact
	//and concatenates all of those strings together and returns the resulting string.
	//This should be the wiki syntax of the whole document.
	public String toWiki() {
		String wikiFileString = new String("");
		for (int i = 0; i < artifacts.size(); i++) {
			wikiFileString =
				wikiFileString.concat(
					(String) ((Artifact) artifacts.elementAt(i)).toWiki());
			if (((Artifact) artifacts.elementAt(i)).getText().endsWith("\n"))
				wikiFileString = wikiFileString.concat("\n");
		}

		return wikiFileString;
	}

	//This function outputs the wiki document to the specified file path.
	public void outputWikiDoc(String filePath) {

		FileOutputStream wikiFile;

		try {
			wikiFile = new FileOutputStream(filePath);
			wikiFile.write((byte[]) (this.toWiki()).getBytes());
			wikiFile.close();

		} catch (Exception e) {

			e.printStackTrace();
		}

	}

	//This function inserts the artifact parameter into the ArtifactList at the specified index.
	public void insertArtifact(Artifact newArt, int index) {
		if (index == -1) {
			artifacts.addElement(newArt);
		} else {
			artifacts.insertElementAt(newArt, index);
		}
	}

	//	Returns the Artifact at the specified index
	public Artifact getArtifact(int index) {
		return (Artifact) artifacts.elementAt(index);
	}

	//	Returns the current Artifact
	public Artifact getCurrentArtifact() {
		return (Artifact) artifacts.elementAt(artIndex);
	}

	// Sets the current artifact
	public void setCurrentArtifact(int newArtIndex) {
		
		artIndex = newArtIndex;
		if(artIndex >=numArtifacts)
			artIndex = numArtifacts -1;
	}

	/*Adds the observer to the list of observers*/
	public void addObserver(Observer ob) {
		observers.add(ob);
	}

	public void removeObserver(Observer ob) {
		observers.remove(ob);
	}

	//This function is used to split a artifact up in the middle and divide into two
	//	It is called when I am in the middle of an artifact and I try to create a new artifact in between
	public void splitArtifact() {
		boolean[] sbits = getCurrentArtifact().getStyleBits();
		//System.out.println("CurrentArtifact: " + getCurrentArtifact() + "Text: " + getCurrentArtifact().getText());
		//System.out.println("Substring: 0 , " + getArtifact(artIndex).getWhereInText());
		String one =
			getCurrentArtifact().getText().substring(
				0,
				getCurrentArtifact().getWhereInText());
		//System.out.println("one: " + one);
		String two =
			getCurrentArtifact().getText().substring(
				getCurrentArtifact().getWhereInText(),
				getArtifact(artIndex).getText().length());
		//System.out.println("two: " + two);

		artifacts.add(artIndex, new Artifact(sbits));

		getCurrentArtifact().setText(one);
		getArtifact(artIndex + 1).setText(two);

		artIndex++;
		numArtifacts++;
	}

	//This function is called when any of the arrow keys is pressed or a mouse is clicked in the textpane
	//	It basically takes an int position and updates the artifactlist wherever required.
	public void updatePosition(int position) {
		int currCharPos = 0;
		int currArt = 0;
		for (currArt = 0; currArt < numArtifacts; currArt++) {
			if ((getArtifact(currArt).numOutputChars() + currCharPos)
				< position) {
				currCharPos =
					getArtifact(currArt).numOutputChars() + currCharPos;
				/*	System.out.print("numOutChars: ");
					System.out.println(getArtifact(currArt).numOutputChars());*/
			} else {
				break;
			}
		}
		setCurrentArtifact(currArt);
		getCurrentArtifact().setWhereInText(position - currCharPos);
		styleBits = getCurrentArtifact().getStyleBits();
		/*System.out.print("pos-currCharPos: ");
		System.out.println(position-currCharPos);*/
	}

	public String cutSelection() {
		int selStart = getController().selectStart,
			selEnd = getController().selectEnd;
		int firstArt, lastArt;
		String whatWasCut = new String("");
		if (selStart == selEnd)
			return "";
		if (selStart > selEnd) {
			selStart = getController().selectEnd;
			selEnd = getController().selectStart;
		}
		getController().selectEnd = 0;
		getController().selectStart = 0;
		updatePosition(selStart);
		firstArt = artIndex;
		if (getCurrentArtifact().getWhereInText() > 0
			&& getCurrentArtifact().getWhereInText()
				< getCurrentArtifact().getText().length()) {
			splitArtifact();
			firstArt = artIndex;
		}
		updatePosition(selEnd);
		lastArt = artIndex;
		if (getCurrentArtifact().getWhereInText() > 0
			&& getCurrentArtifact().getWhereInText()
				< getCurrentArtifact().getText().length()) {
			splitArtifact();
			lastArt = artIndex - 1;
		}
		while (firstArt <= lastArt) {
			whatWasCut = whatWasCut.concat(getArtifact(firstArt).getText());
			artifacts.remove(firstArt);
			lastArt--;
		}
		//outputWikiDoc("C:\\thisiscraziness.wiki");
		//try {
			loadFromString(toWiki());
		//} catch (IOException e) {

		//	e.printStackTrace();
		//}
		updatePosition(selStart);
		getView().textPane.setCaretPosition(selStart);

		return whatWasCut;
	}

}
