/*
 * Created on Dec 14, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package wikiviz;

/**
 * @author Larry Benchimol
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TextArtifact extends Artifact {

	//	As user enters text in the text area in GUI that
	// text is saved in String "text"
	// whereInText keeps track of the position in the text string
	protected String text;
	private int whereInText;

	public TextArtifact() {
		subArt = null;
		styleString = "";
		text = "";
		whereInText = 0;

		startTag = new String("");
		endTag = new String("");
	}

	public TextArtifact(int i) {
		subArt = null;
		text = "";
		whereInText = 0;

		startTag = new String("");
		endTag = new String("");
	}

	public String deleteChar(){
		System.out.println("whereInText = "+whereInText);
		String firstString = text.substring(0, whereInText-1);
		String lastString;
		if (whereInText < text.length()) {
			lastString = text.substring(whereInText);
		} else {
			lastString = "";
		}
		//firstString = firstString.concat(String.valueOf(newChar));
		text = firstString.concat(lastString);
		whereInText--;
		return text;
	}
	
	//sets the text of the artifact
	public void setText(String textArtifact) {
		text = textArtifact;
		whereInText = text.length();// - 1;
	}

	//returns the string stored in the artifact
	public String getText() {
		return text;
	}

	// we can set the position in the text
	public void setWhereInText(int i) {
		whereInText = i;
	}

	// Retrive whereInText
	public int getWhereInText() {
		return whereInText;
	}

	//set the position to the end of the text
	public void setWhereInTextToEnd() {
		whereInText = text.length();
	}

	//true if at the end of the text
	public boolean isAtEndOfArtifact() {
		return (whereInText == text.length());
	}

	public boolean isAtStart() {
		return (whereInText == 0);
	}

	//adds the newChar to the appropriate position in the text
	public void append(char newChar) {
		if (whereInText == 0) {
			String firstString = new String(String.valueOf(newChar));
			text = firstString.concat(text);
		} else {
			String firstString = text.substring(0, whereInText);
			String lastString;
			if (whereInText < text.length()) {
				lastString = text.substring(whereInText);
			} else {
				lastString = "";
			}
			firstString = firstString.concat(String.valueOf(newChar));
			text = firstString.concat(lastString);
		}
		whereInText++;
	}

	//removes numChars characters from the current position in the text
	public String removeChars(int numChars) {
		String newText = text.substring(0, text.length() - numChars);
		String removeChars =
			text.substring(text.length() - numChars, text.length());
		text = newText;
		whereInText = whereInText-numChars;
		return removeChars;
	}

	//This function returns the lentgh the input string that user
	//typed in text area in GUI
	public int numOutputChars() {
		return text.length();
	}

	//This function returns the string that was typed
	public String toWiki() {
		String out = escapeChars(text);
		if (out.endsWith("\n"))
			return out.substring(0, out.length() - 1);
		return out;
	}

	public String getStyleString() {
		return styleString;
	}

	private String escapeChars(String text) {
		String outText = new String("");
		for (int i = 0; i < text.length(); i++) {
			if (text.charAt(i) == '*' || text.charAt(i) == '!')
				outText = outText.concat("\\");
			outText = outText.concat(String.valueOf(text.charAt(i)));
		}
		return outText;
	}
}
